searchNodes=[{"ref":"Memcache.html","title":"Memcache","type":"module","doc":"This module provides a user friendly API to interact with the memcached server. Example {:ok, pid} = Memcache.start_link() {:ok} = Memcache.set(pid, &quot;hello&quot;, &quot;world&quot;) {:ok, &quot;world&quot;} = Memcache.get(pid, &quot;hello&quot;) Coder Memcache.Coder allows you to specify how the value should be encoded before sending it to the server and how it should be decoded after it is retrived. There are four built-in coders namely Memcache.Coder.Raw, Memcache.Coder.Erlang, Memcache.Coder.JSON, Memcache.Coder.ZIP. Custom coders can be created by implementing the Memcache.Coder behaviour. CAS CAS feature allows to atomically perform two commands on a key. Get the cas version number associated with a key during the first command and pass that value during the second command. The second command will fail if the value has changed by someone else in the mean time. {:ok, &quot;hello&quot;, cas} = Memcache.get(pid, &quot;key&quot;, cas: true) {:ok} = Memcache.set_cas(pid, &quot;key&quot;, &quot;world&quot;, cas) Memcache module provides a *_cas variant for most of the functions. This function will take an additional argument named cas and returns the same value as their counterpart except in case of CAS error. In case of CAS error the returned value would be equal to {:error, &quot;Key exists&quot;} Telemetry The following telemetry events are published: [:memcachex, :commands] - executed for every successful commands Measurements :elapsed_time - (integer - native time unit) the time it took to send the commands to the server and get a reply. Metadata :server - (binary) hostname and port of the server :commands - (list) list of command :results - (list) list of response from the server :start_time - (integer - native time unit) system time when the commands were issued [:memcachex, :commands_error] - executed for every failed commands Measurements :elapsed_time - (integer - native time unit) the time it took to send the commands to the server and get a reply. Metadata :server - (binary) hostname and port of the server :commands - (list) list of command :reason - (atom) error reason :start_time - (integer - native time unit) system time when the commands were issued [:memcachex, :connection] - executed after successful connection. Metadata :server - (binary) hostname and port of the server :reconnected - (boolean) set to true for reconnection [:memcachex, :connection_error] - executed on connection failure. Metadata :server - (binary) hostname and port of the server :reason - (atom) error reason Options Most the functions in this module accept an optional Keyword list. The below list specifies the behavior of each option. The list of option accepted by a specific function will be documented in the specific funcion. :cas - (boolean) returns the CAS value associated with the data. This value will be either in second or third position of the returned tuple depending on the command. Defaults to false. :ttl - (integer) specifies the expiration time in seconds for the corresponding key. Can be set to 0 to disable expiration. The Default value can be configured using start_link/2."},{"ref":"Memcache.html#add/4","title":"Memcache.add/4","type":"function","doc":"Sets the key to value if the key doesn&#39;t exist already. Returns {:error, &quot;Key exists&quot;} if the given key already exists. Accepted options: :cas, :ttl"},{"ref":"Memcache.html#append/4","title":"Memcache.append/4","type":"function","doc":"Appends the value to the end of the current value of the key. Returns {:error, &quot;Item not stored&quot;} if the item is not present in the server already Accepted options: :cas"},{"ref":"Memcache.html#append_cas/5","title":"Memcache.append_cas/5","type":"function","doc":"Appends the value to the end of the current value of the key if the CAS value is equal to the provided value Accepted options: :cas"},{"ref":"Memcache.html#cas/4","title":"Memcache.cas/4","type":"function","doc":"Compare and swap value using optimistic locking. Get the existing value for key If it exists, call the update function with the value Set the returned value for key The 3rd operation will fail if someone else has updated the value for the same key in the mean time. In that case, by default, this function will go to step 1 and try again. Retry behavior can be disabled by passing [retry: false] option."},{"ref":"Memcache.html#decr/3","title":"Memcache.decr/3","type":"function","doc":"Decremens the current value. Only integer value can be decremented. Returns {:error, &quot;Incr/Decr on non-numeric value&quot;} if the value stored in the server is not numeric. Options :by - (integer) The amount to add to the existing value. Defaults to 1. :default - (integer) Default value to use in case the key is not found. Defaults to 0. other options: :cas, :ttl"},{"ref":"Memcache.html#decr_cas/4","title":"Memcache.decr_cas/4","type":"function","doc":"Decrements the current value if the CAS value is equal to the provided value. Options :by - (integer) The amount to add to the existing value. Defaults to 1. :default - (integer) Default value to use in case the key is not found. Defaults to 0. other options: :cas, :ttl"},{"ref":"Memcache.html#delete/2","title":"Memcache.delete/2","type":"function","doc":"Removes the item with the given key value. Returns {:error, &quot;Key not found&quot;} if the given key is not found"},{"ref":"Memcache.html#delete_cas/3","title":"Memcache.delete_cas/3","type":"function","doc":"Removes the item with the given key value if the CAS value is equal to the provided value"},{"ref":"Memcache.html#flush/2","title":"Memcache.flush/2","type":"function","doc":"Flush all the items in the server. ttl option will cause the flush to be delayed by the specified time. Accepted options: :ttl"},{"ref":"Memcache.html#get/3","title":"Memcache.get/3","type":"function","doc":"Gets the value associated with the key. Returns {:error, &quot;Key not found&quot;} if the given key doesn&#39;t exist. Accepted option: :cas"},{"ref":"Memcache.html#incr/3","title":"Memcache.incr/3","type":"function","doc":"Increments the current value. Only integer value can be incremented. Returns {:error, &quot;Incr/Decr on non-numeric value&quot;} if the value stored in the server is not numeric. Options :by - (integer) The amount to add to the existing value. Defaults to 1. :default - (integer) Default value to use in case the key is not found. Defaults to 0. other options: :cas, :ttl"},{"ref":"Memcache.html#incr_cas/4","title":"Memcache.incr_cas/4","type":"function","doc":"Increments the current value if the CAS value is equal to the provided value. Options :by - (integer) The amount to add to the existing value. Defaults to 1. :default - (integer) Default value to use in case the key is not found. Defaults to 0. other options: :cas, :ttl"},{"ref":"Memcache.html#multi_get/3","title":"Memcache.multi_get/3","type":"function","doc":"Gets the values associated with the list of keys. Returns a map. Keys that are not found in the server are filtered from the result. Accepted option: :cas"},{"ref":"Memcache.html#multi_set/3","title":"Memcache.multi_set/3","type":"function","doc":"Multi version of set/4. Accepts a map or a list of {key, value}. Accepted options: :cas, :ttl"},{"ref":"Memcache.html#multi_set_cas/3","title":"Memcache.multi_set_cas/3","type":"function","doc":"Multi version of set_cas/4. Accepts a list of {key, value, cas}. Accepted options: :cas, :ttl"},{"ref":"Memcache.html#noop/1","title":"Memcache.noop/1","type":"function","doc":"Sends a noop command"},{"ref":"Memcache.html#prepend/4","title":"Memcache.prepend/4","type":"function","doc":"Prepends the value to the start of the current value of the key. Returns {:error, &quot;Item not stored&quot;} if the item is not present in the server already Accepted options: :cas"},{"ref":"Memcache.html#prepend_cas/5","title":"Memcache.prepend_cas/5","type":"function","doc":"Prepends the value to the start of the current value of the key if the CAS value is equal to the provided value Accepted options: :cas"},{"ref":"Memcache.html#replace/4","title":"Memcache.replace/4","type":"function","doc":"Sets the key to value if the key already exists. Returns {:error, &quot;Key not found&quot;} if the given key doesn&#39;t exist. Accepted options: :cas, :ttl"},{"ref":"Memcache.html#replace_cas/5","title":"Memcache.replace_cas/5","type":"function","doc":"Sets the key to value if the key already exists and has CAS value equal to the provided value. Accepted options: :cas, :ttl"},{"ref":"Memcache.html#set/4","title":"Memcache.set/4","type":"function","doc":"Sets the key to value Accepted options: :cas, :ttl"},{"ref":"Memcache.html#set_cas/5","title":"Memcache.set_cas/5","type":"function","doc":"Sets the key to value if the key exists and has CAS value equal to the provided value Accepted options: :cas, :ttl"},{"ref":"Memcache.html#start_link/2","title":"Memcache.start_link/2","type":"function","doc":"Creates a connection using Memcache.Connection.start_link/2 Connection Options This is a superset of the connection options accepted by the Memcache.Connection.start_link/2. The following list specifies the additional options. :ttl - (integer) a default expiration time in seconds. This value will be used if the :ttl value is not specified for a operation. Defaults to 0(means forever). :namespace - (string) prepend each key with the given value. :key_coder - ({module, function}) Used to transform the key completely. The function needs to accept one argument, the key and return a new key. :coder - (module | {module, options}) Can be either a module or tuple contains the module and options. Defaults to {Memcache.Coder.Raw, []}. Options The second option is passed directly to the underlying GenServer.start_link/3, so it can be used to create named process."},{"ref":"Memcache.html#stat/1","title":"Memcache.stat/1","type":"function","doc":"Gets the default set of server statistics"},{"ref":"Memcache.html#stat/2","title":"Memcache.stat/2","type":"function","doc":"Gets the specific set of server statistics"},{"ref":"Memcache.html#stop/1","title":"Memcache.stop/1","type":"function","doc":"Closes the connection to the memcached server."},{"ref":"Memcache.html#version/1","title":"Memcache.version/1","type":"function","doc":"Gets the version of the server"},{"ref":"Memcache.html#t:error/0","title":"Memcache.error/0","type":"type","doc":""},{"ref":"Memcache.html#t:fetch_integer_result/0","title":"Memcache.fetch_integer_result/0","type":"type","doc":""},{"ref":"Memcache.html#t:fetch_result/0","title":"Memcache.fetch_result/0","type":"type","doc":""},{"ref":"Memcache.html#t:result/0","title":"Memcache.result/0","type":"type","doc":""},{"ref":"Memcache.html#t:store_result/0","title":"Memcache.store_result/0","type":"type","doc":""},{"ref":"Memcache.html#t:value/0","title":"Memcache.value/0","type":"type","doc":""},{"ref":"Memcache.Coder.html","title":"Memcache.Coder","type":"behaviour","doc":"Defines the Memcache.Coder behaviour. A list would be passed to both encode/2 and decode/2 callbacks. This value can be specified by the user. Defaults to [] incase it is not specified."},{"ref":"Memcache.Coder.html#c:decode/2","title":"Memcache.Coder.decode/2","type":"callback","doc":"Called after the value is loaded from the server. It can return any type."},{"ref":"Memcache.Coder.html#c:encode/2","title":"Memcache.Coder.encode/2","type":"callback","doc":"Called before the value is sent to the server. It should return iodata."},{"ref":"Memcache.Coder.Erlang.html","title":"Memcache.Coder.Erlang","type":"module","doc":"Uses :erlang.term_to_binary/2 and :erlang.binary_to_term/1 to encode and decode value."},{"ref":"Memcache.Coder.Erlang.html#decode/2","title":"Memcache.Coder.Erlang.decode/2","type":"function","doc":"Called after the value is loaded from the server. It can return any type. Callback implementation for Memcache.Coder.decode/2."},{"ref":"Memcache.Coder.Erlang.html#encode/2","title":"Memcache.Coder.Erlang.encode/2","type":"function","doc":"Called before the value is sent to the server. It should return iodata. Callback implementation for Memcache.Coder.encode/2."},{"ref":"Memcache.Coder.JSON.html","title":"Memcache.Coder.JSON","type":"module","doc":"Uses the Poison module to encode and decode value. To use this coder add poison as a dependency in mix.exs."},{"ref":"Memcache.Coder.JSON.html#decode/2","title":"Memcache.Coder.JSON.decode/2","type":"function","doc":"Called after the value is loaded from the server. It can return any type. Callback implementation for Memcache.Coder.decode/2."},{"ref":"Memcache.Coder.JSON.html#encode/2","title":"Memcache.Coder.JSON.encode/2","type":"function","doc":"Called before the value is sent to the server. It should return iodata. Callback implementation for Memcache.Coder.encode/2."},{"ref":"Memcache.Coder.Raw.html","title":"Memcache.Coder.Raw","type":"module","doc":"Doesn&#39;t do any conversion. Stores the value as it is in the server."},{"ref":"Memcache.Coder.Raw.html#decode/2","title":"Memcache.Coder.Raw.decode/2","type":"function","doc":"Called after the value is loaded from the server. It can return any type. Callback implementation for Memcache.Coder.decode/2."},{"ref":"Memcache.Coder.Raw.html#encode/2","title":"Memcache.Coder.Raw.encode/2","type":"function","doc":"Called before the value is sent to the server. It should return iodata. Callback implementation for Memcache.Coder.encode/2."},{"ref":"Memcache.Coder.ZIP.html","title":"Memcache.Coder.ZIP","type":"module","doc":"Uses :zlib.zip/1 and :zlib.unzip/1 to compress and decompress value."},{"ref":"Memcache.Coder.ZIP.html#decode/2","title":"Memcache.Coder.ZIP.decode/2","type":"function","doc":"Called after the value is loaded from the server. It can return any type. Callback implementation for Memcache.Coder.decode/2."},{"ref":"Memcache.Coder.ZIP.html#encode/2","title":"Memcache.Coder.ZIP.encode/2","type":"function","doc":"Called before the value is sent to the server. It should return iodata. Callback implementation for Memcache.Coder.encode/2."},{"ref":"Memcache.Connection.html","title":"Memcache.Connection","type":"module","doc":"This module provides low level API to connect and execute commands on a memcached server."},{"ref":"Memcache.Connection.html#cleanup/1","title":"Memcache.Connection.cleanup/1","type":"function","doc":""},{"ref":"Memcache.Connection.html#close/1","title":"Memcache.Connection.close/1","type":"function","doc":"Closes the connection to the memcached server. Example iex&gt; {:ok, pid} = Memcache.Connection.start_link() iex&gt; Memcache.Connection.close(pid) {:ok}"},{"ref":"Memcache.Connection.html#execute/4","title":"Memcache.Connection.execute/4","type":"function","doc":"Executes the command with the given args options :cas - (boolean) returns the CAS value associated with the data. This value will be either in second or third position of the returned tuple depending on the command. Defaults to false Example iex&gt; {:ok, pid} = Memcache.Connection.start_link() iex&gt; {:ok} = Memcache.Connection.execute(pid, :SET, [&quot;hello&quot;, &quot;world&quot;]) iex&gt; {:ok, &quot;world&quot;} = Memcache.Connection.execute(pid, :GET, [&quot;hello&quot;]) {:ok, &quot;world&quot;}"},{"ref":"Memcache.Connection.html#execute_quiet/2","title":"Memcache.Connection.execute_quiet/2","type":"function","doc":"Executes the list of quiet commands Example iex&gt; {:ok, pid} = Memcache.Connection.start_link() iex&gt; {:ok, [{:ok}, {:ok}]} = Memcache.Connection.execute_quiet(pid, [{:SETQ, [&quot;1&quot;, &quot;one&quot;]}, {:SETQ, [&quot;2&quot;, &quot;two&quot;]}]) iex&gt; Memcache.Connection.execute_quiet(pid, [{:GETQ, [&quot;1&quot;]}, {:GETQ, [&quot;2&quot;]}]) {:ok, [{:ok, &quot;one&quot;}, {:ok, &quot;two&quot;}]}"},{"ref":"Memcache.Connection.html#start_link/2","title":"Memcache.Connection.start_link/2","type":"function","doc":"Starts a connection to memcached server. The actual TCP connection to the memcached server is established asynchronously after the start_link/2 returns. This function accepts two option lists. The first one specifies the options to connect to the memcached server. The second option is passed directly to the underlying GenServer.start_link/3, so it can be used to create named process. Memcachex automatically tries to reconnect in case of tcp connection failures. It starts with a :backoff_initial wait time and increases the wait time exponentially on each successive failures until it reaches the :backoff_max. After that, it waits for :backoff_max after each failure. Connection Options :hostname - (string) hostname of the memcached server. Defaults to &quot;localhost&quot; :port - (integer) port on which the memcached server is listening. Defaults to 11211 :backoff_initial - (integer) initial backoff (in milliseconds) to be used in case of connection failure. Defaults to 500 :backoff_max - (integer) maximum allowed interval between two connection attempt. Defaults to 30_000 :auth - (tuple) only plain authentication method is supported. It is specified using the following format {:plain, &quot;username&quot;, &quot;password&quot;}. Defaults to nil. Example {:ok, pid} = Memcache.Connection.start_link()"},{"ref":"readme.html","title":"Memcache","type":"extras","doc":"Memcache Memcached client for Elixir"},{"ref":"readme.html#installation","title":"Memcache - Installation","type":"extras","doc":"defp deps() do [{:memcachex, &quot;~&gt; 0.4&quot;}] end"},{"ref":"readme.html#overview","title":"Memcache - Overview","type":"extras","doc":"Memcachex comes with two kinds of API, a high level one named Memcache which provides functions to perform most of the common usecases and a low level one named Memcache.Connection which provides a less restrictive API. See the documentation for more information"},{"ref":"readme.html#example","title":"Memcache - Example","type":"extras","doc":"{:ok, pid} = Memcache.start_link() {:ok} = Memcache.set(pid, &quot;hello&quot;, &quot;world&quot;) {:ok, &quot;world&quot;} = Memcache.get(pid, &quot;hello&quot;) See test folder for further examples."}]